package com.huimv.admin.reader;

import com.gg.reader.api.dal.*;
import com.gg.reader.api.protocol.gx.*;

public class Read6b {
    public static void main(String[] args) {
        GClient client = new GClient();
        if (client.openSerial("COM7:115200", 2000)) {
            subscribeHandler(client);

            MsgBaseInventory6b msgBaseInventory6b = new MsgBaseInventory6b();
            msgBaseInventory6b.setAntennaEnable(EnumG.AntennaNo_1);
            msgBaseInventory6b.setArea(EnumG.ReadMode6b_Tid);
            msgBaseInventory6b.setInventoryMode(EnumG.InventoryMode_Inventory);
            client.sendSynMsg(msgBaseInventory6b);
            if (0x00 == msgBaseInventory6b.getRtCode()) {
                System.out.println("MsgBaseInventory6b[OK].");
            } else {
                System.out.println(msgBaseInventory6b.getRtMsg());
            }

            try {
                Thread.sleep(5000);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }

            MsgBaseStop stopMsg = new MsgBaseStop();
            client.sendSynMsg(stopMsg);
            if (0x00 == stopMsg.getRtCode()) {
                System.out.println("MsgBaseStop Success");
            } else {
                System.out.println("MsgBaseStop Fail");
            }

            System.out.println("Close the connection");
            client.close();
        }
    }


    //订阅6b标签信息上报
    private static void subscribeHandler(GClient client) {
        client.onTag6bLog = new HandlerTag6bLog() {
            @Override
            public void log(String s, LogBase6bInfo logBase6bInfo) {
                if (null != logBase6bInfo && logBase6bInfo.getResult() == 0) {
                    System.out.println(logBase6bInfo);
                }
            }
        };

        client.onTag6bOver = new HandlerTag6bOver() {
            @Override
            public void log(String s, LogBase6bOver logBase6bOver) {
                System.out.println("HandlerTag6bOver");
            }
        };
    }
}
